diff --git a/rtemsbsd/include/machine/rtems-bsd-kernel-namespace.h b/rtemsbsd/include/machine/rtems-bsd-kernel-namespace.h
index 293c6115..9d3472d6 100644
--- a/rtemsbsd/include/machine/rtems-bsd-kernel-namespace.h
+++ b/rtemsbsd/include/machine/rtems-bsd-kernel-namespace.h
@@ -3813,6 +4146,28 @@
 #define	pfr_table_count _bsd_pfr_table_count
 #define	pfr_tst_addrs _bsd_pfr_tst_addrs
 #define	pfr_update_stats _bsd_pfr_update_stats
+#define	pfs_cmount _bsd_pfs_cmount
+#define	pfs_create_dir _bsd_pfs_create_dir
+#define	pfs_create_file _bsd_pfs_create_file
+#define	pfs_create_link _bsd_pfs_create_link
+#define	pfs_destroy _bsd_pfs_destroy
+#define	pfs_fileno_alloc _bsd_pfs_fileno_alloc
+#define	pfs_fileno_free _bsd_pfs_fileno_free
+#define	pfs_fileno_init _bsd_pfs_fileno_init
+#define	pfs_fileno_uninit _bsd_pfs_fileno_uninit
+#define	pfs_find_node _bsd_pfs_find_node
+#define	pfs_init _bsd_pfs_init
+#define	pfs_mount _bsd_pfs_mount
+#define	pfs_purge _bsd_pfs_purge
+#define	pfs_root _bsd_pfs_root
+#define	pfs_statfs _bsd_pfs_statfs
+#define	pfs_uninit _bsd_pfs_uninit
+#define	pfs_unmount _bsd_pfs_unmount
+#define	pfs_vncache_alloc _bsd_pfs_vncache_alloc
+#define	pfs_vncache_free _bsd_pfs_vncache_free
+#define	pfs_vncache_load _bsd_pfs_vncache_load
+#define	pfs_vncache_unload _bsd_pfs_vncache_unload
+#define	pfs_vnodeops _bsd_pfs_vnodeops
 #define	pfsync_clear_states_ptr _bsd_pfsync_clear_states_ptr
 #define	pfsync_cloner _bsd_pfsync_cloner
 #define	pfsync_defer_ptr _bsd_pfsync_defer_ptr
@@ -3829,14 +4184,20 @@
 #define	pick_mode_by_ref _bsd_pick_mode_by_ref
 #define	pipe_dtor _bsd_pipe_dtor
 #define	pipe_named_ctor _bsd_pipe_named_ctor
+#define	pipeops _bsd_pipeops
 #define	pipeselwakeup _bsd_pipeselwakeup
 #define	pmtu_expire _bsd_pmtu_expire
 #define	pmtu_probe _bsd_pmtu_probe
 #define	poll_no_poll _bsd_poll_no_poll
 #define	ppsratecheck _bsd_ppsratecheck
+#define	print_devclass_list _bsd_print_devclass_list
+#define	print_devclass_list_short _bsd_print_devclass_list_short
+#define	print_device_tree _bsd_print_device_tree
+#define	print_device_tree_short _bsd_print_device_tree_short
 #define	printf _bsd_printf
 #define	printf_uuid _bsd_printf_uuid
 #define	prison0 _bsd_prison0
+#define	proc0 _bsd_proc0
 #define	pru_accept_notsupp _bsd_pru_accept_notsupp
 #define	pru_aio_queue_notsupp _bsd_pru_aio_queue_notsupp
 #define	pru_attach_notsupp _bsd_pru_attach_notsupp
@@ -3859,6 +4220,8 @@
 #define	pru_sopoll_notsupp _bsd_pru_sopoll_notsupp
 #define	pru_soreceive_notsupp _bsd_pru_soreceive_notsupp
 #define	pru_sosend_notsupp _bsd_pru_sosend_notsupp
+#define	pwd_chdir _bsd_pwd_chdir
+#define	pwd_ensure_dirs _bsd_pwd_ensure_dirs
 #define	qgroup_config _bsd_qgroup_config
 #define	qgroup_if_config_tqg _bsd_qgroup_if_config_tqg
 #define	qgroup_if_io_tqg _bsd_qgroup_if_io_tqg
@@ -4088,6 +4451,7 @@
 #define	rc4_init _bsd_rc4_init
 #define	read_dsfield _bsd_read_dsfield
 #define	read_machclk _bsd_read_machclk
+#define	reassignbuf _bsd_reassignbuf
 #define	refcount_release_last _bsd_refcount_release_last
 #define	refcount_sleep _bsd_refcount_sleep
 #define	register_tcp_functions _bsd_register_tcp_functions
@@ -4130,6 +4494,8 @@
 #define	regulator_set_voltage _bsd_regulator_set_voltage
 #define	regulator_status _bsd_regulator_status
 #define	regulator_stop _bsd_regulator_stop
+#define	relookup _bsd_relookup
+#define	relpbuf _bsd_relpbuf
 #define	resource_disabled _bsd_resource_disabled
 #define	resource_find_match _bsd_resource_find_match
 #define	resource_int_value _bsd_resource_int_value
@@ -4348,6 +4714,8 @@
 #define	rtwn_usb_write_4 _bsd_rtwn_usb_write_4
 #define	rtwn_usb_write_region_1 _bsd_rtwn_usb_write_region_1
 #define	run_debug _bsd_run_debug
+#define	runningbufspace _bsd_runningbufspace
+#define	runningbufwakeup _bsd_runningbufwakeup
 #define	rw_destroy _bsd_rw_destroy
 #define	rw_init_flags _bsd_rw_init_flags
 #define	rw_sysinit _bsd_rw_sysinit
@@ -4833,10 +5201,13 @@
 #define	selwakeuppri _bsd_selwakeuppri
 #define	send_forward_tsn _bsd_send_forward_tsn
 #define	send_sendso_input_hook _bsd_send_sendso_input_hook
+#define	setfmode _bsd_setfmode
+#define	setfown _bsd_setfown
 #define	sha1_init _bsd_sha1_init
 #define	sha1_loop _bsd_sha1_loop
 #define	sha1_pad _bsd_sha1_pad
 #define	sha1_result _bsd_sha1_result
+#define	sigio_lock _bsd_sigio_lock
 #define	simplebus_add_device _bsd_simplebus_add_device
 #define	simplebus_driver _bsd_simplebus_driver
 #define	simplebus_fill_ranges _bsd_simplebus_fill_ranges
@@ -4929,6 +5300,7 @@
 #define	sonewconn _bsd_sonewconn
 #define	soo_close _bsd_soo_close
 #define	soo_ioctl _bsd_soo_ioctl
+#define	soo_kqfilter _bsd_soo_kqfilter
 #define	soo_poll _bsd_soo_poll
 #define	soo_read _bsd_soo_read
 #define	soo_write _bsd_soo_write
@@ -4954,6 +5326,7 @@
 #define	soupcall_clear _bsd_soupcall_clear
 #define	soupcall_set _bsd_soupcall_set
 #define	sowakeup _bsd_sowakeup
+#define	speedup_syncer _bsd_speedup_syncer
 #define	sppp_attach _bsd_sppp_attach
 #define	sppp_dequeue _bsd_sppp_dequeue
 #define	sppp_detach _bsd_sppp_detach
@@ -4967,6 +5340,7 @@
 #define	sppp_isempty _bsd_sppp_isempty
 #define	sppp_pick _bsd_sppp_pick
 #define	sprintf _bsd_sprintf
+#define	statfs_scale_blocks _bsd_statfs_scale_blocks
 #define	subkey_table_gen _bsd_subkey_table_gen
 #define	swi_add _bsd_swi_add
 #define	swi_sched _bsd_swi_sched
@@ -4974,7 +5348,9 @@
 #define	sx_downgrade_int _bsd_sx_downgrade_int
 #define	sx_init_flags _bsd_sx_init_flags
 #define	sx_sysinit _bsd_sx_sysinit
+#define	sx_try_downgrade_ _bsd_sx_try_downgrade_
 #define	sx_try_slock_int _bsd_sx_try_slock_int
+#define	sx_try_upgrade_ _bsd_sx_try_upgrade_
 #define	sx_try_upgrade_int _bsd_sx_try_upgrade_int
 #define	sx_xlocked _bsd_sx_xlocked
 #define	syncache_add _bsd_syncache_add
@@ -4984,6 +5360,104 @@
 #define	syncache_init _bsd_syncache_init
 #define	syncache_pcblist _bsd_syncache_pcblist
 #define	syncache_unreach _bsd_syncache_unreach
+#define	syncer_resume _bsd_syncer_resume
+#define	syncer_suspend _bsd_syncer_suspend
+#define	sys___acl_aclcheck_fd _bsd_sys___acl_aclcheck_fd
+#define	sys___acl_aclcheck_file _bsd_sys___acl_aclcheck_file
+#define	sys___acl_aclcheck_link _bsd_sys___acl_aclcheck_link
+#define	sys___acl_delete_fd _bsd_sys___acl_delete_fd
+#define	sys___acl_delete_file _bsd_sys___acl_delete_file
+#define	sys___acl_delete_link _bsd_sys___acl_delete_link
+#define	sys___acl_get_fd _bsd_sys___acl_get_fd
+#define	sys___acl_get_file _bsd_sys___acl_get_file
+#define	sys___acl_get_link _bsd_sys___acl_get_link
+#define	sys___acl_set_fd _bsd_sys___acl_set_fd
+#define	sys___acl_set_file _bsd_sys___acl_set_file
+#define	sys___acl_set_link _bsd_sys___acl_set_link
+#define	sys___getcwd _bsd_sys___getcwd
+#define	sys_accept _bsd_sys_accept
+#define	sys_accept4 _bsd_sys_accept4
+#define	sys_access _bsd_sys_access
+#define	sys_aio_cancel _bsd_sys_aio_cancel
+#define	sys_aio_error _bsd_sys_aio_error
+#define	sys_aio_fsync _bsd_sys_aio_fsync
+#define	sys_aio_mlock _bsd_sys_aio_mlock
+#define	sys_aio_read _bsd_sys_aio_read
+#define	sys_aio_return _bsd_sys_aio_return
+#define	sys_aio_suspend _bsd_sys_aio_suspend
+#define	sys_aio_waitcomplete _bsd_sys_aio_waitcomplete
+#define	sys_aio_write _bsd_sys_aio_write
+#define	sys_bind _bsd_sys_bind
+#define	sys_chdir _bsd_sys_chdir
+#define	sys_chflags _bsd_sys_chflags
+#define	sys_chmod _bsd_sys_chmod
+#define	sys_chown _bsd_sys_chown
+#define	sys_close _bsd_sys_close
+#define	sys_connect _bsd_sys_connect
+#define	sys_fchdir _bsd_sys_fchdir
+#define	sys_fchmod _bsd_sys_fchmod
+#define	sys_fchmodat _bsd_sys_fchmodat
+#define	sys_fchown _bsd_sys_fchown
+#define	sys_fchownat _bsd_sys_fchownat
+#define	sys_fdatasync _bsd_sys_fdatasync
+#define	sys_fstat _bsd_sys_fstat
+#define	sys_fstatat _bsd_sys_fstatat
+#define	sys_fstatfs _bsd_sys_fstatfs
+#define	sys_fsync _bsd_sys_fsync
+#define	sys_ftruncate _bsd_sys_ftruncate
+#define	sys_getdirentries _bsd_sys_getdirentries
+#define	sys_getdtablesize _bsd_sys_getdtablesize
+#define	sys_getfsstat _bsd_sys_getfsstat
+#define	sys_getpeername _bsd_sys_getpeername
+#define	sys_getsockname _bsd_sys_getsockname
+#define	sys_getsockopt _bsd_sys_getsockopt
+#define	sys_ioctl _bsd_sys_ioctl
+#define	sys_kevent _bsd_sys_kevent
+#define	sys_kqueue _bsd_sys_kqueue
+#define	sys_lchmod _bsd_sys_lchmod
+#define	sys_lchown _bsd_sys_lchown
+#define	sys_link _bsd_sys_link
+#define	sys_linkat _bsd_sys_linkat
+#define	sys_lio_listio _bsd_sys_lio_listio
+#define	sys_listen _bsd_sys_listen
+#define	sys_lseek _bsd_sys_lseek
+#define	sys_mkdir _bsd_sys_mkdir
+#define	sys_mkdirat _bsd_sys_mkdirat
+#define	sys_mknodat _bsd_sys_mknodat
+#define	sys_mount _bsd_sys_mount
+#define	sys_nmount _bsd_sys_nmount
+#define	sys_open _bsd_sys_open
+#define	sys_openat _bsd_sys_openat
+#define	sys_pipe2 _bsd_sys_pipe2
+#define	sys_poll _bsd_sys_poll
+#define	sys_pselect _bsd_sys_pselect
+#define	sys_read _bsd_sys_read
+#define	sys_readlink _bsd_sys_readlink
+#define	sys_readlinkat _bsd_sys_readlinkat
+#define	sys_readv _bsd_sys_readv
+#define	sys_recvfrom _bsd_sys_recvfrom
+#define	sys_recvmsg _bsd_sys_recvmsg
+#define	sys_rename _bsd_sys_rename
+#define	sys_renameat _bsd_sys_renameat
+#define	sys_rmdir _bsd_sys_rmdir
+#define	sys_select _bsd_sys_select
+#define	sys_sendmsg _bsd_sys_sendmsg
+#define	sys_sendto _bsd_sys_sendto
+#define	sys_setfib _bsd_sys_setfib
+#define	sys_setsockopt _bsd_sys_setsockopt
+#define	sys_shutdown _bsd_sys_shutdown
+#define	sys_socket _bsd_sys_socket
+#define	sys_socketpair _bsd_sys_socketpair
+#define	sys_statfs _bsd_sys_statfs
+#define	sys_symlink _bsd_sys_symlink
+#define	sys_symlinkat _bsd_sys_symlinkat
+#define	sys_sync _bsd_sys_sync
+#define	sys_truncate _bsd_sys_truncate
+#define	sys_unlink _bsd_sys_unlink
+#define	sys_unlinkat _bsd_sys_unlinkat
+#define	sys_unmount _bsd_sys_unmount
+#define	sys_write _bsd_sys_write
+#define	sys_writev _bsd_sys_writev
 #define	sysctl___debug _bsd_sysctl___debug
 #define	sysctl___dev _bsd_sysctl___dev
 #define	sysctl___hw _bsd_sysctl___hw
@@ -5045,6 +5519,8 @@
 #define	sysctl___net_wlan _bsd_sysctl___net_wlan
 #define	sysctl___security _bsd_sysctl___security
 #define	sysctl___sysctl _bsd_sysctl___sysctl
+#define	sysctl___vfs _bsd_sysctl___vfs
+#define	sysctl___vfs_pfs _bsd_sysctl___vfs_pfs
 #define	sysctl___vm _bsd_sysctl___vm
 #define	sysctl__children _bsd_sysctl__children
 #define	sysctl_add_oid _bsd_sysctl_add_oid
@@ -5302,6 +5778,7 @@
 #define	timeout _bsd_timeout
 #define	timevaladd _bsd_timevaladd
 #define	timevalsub _bsd_timevalsub
+#define	tprintf _bsd_tprintf
 #define	trash_ctor _bsd_trash_ctor
 #define	trash_dtor _bsd_trash_dtor
 #define	trash_fini _bsd_trash_fini
@@ -5446,7 +5923,12 @@
 #define	uhub_query_info _bsd_uhub_query_info
 #define	uhub_root_intr _bsd_uhub_root_intr
 #define	uhub_tt_buffer_reset_async_locked _bsd_uhub_tt_buffer_reset_async_locked
+#define	uifind _bsd_uifind
+#define	uifree _bsd_uifree
+#define	uihashinit _bsd_uihashinit
+#define	uihold _bsd_uihold
 #define	uiomove _bsd_uiomove
+#define	uiomove_frombuf _bsd_uiomove_frombuf
 #define	uiomove_nofault _bsd_uiomove_nofault
 #define	ukphy_status _bsd_ukphy_status
 #define	ulitecb _bsd_ulitecb
@@ -5454,6 +5936,7 @@
 #define	uma_align_cache _bsd_uma_align_cache
 #define	uma_avail _bsd_uma_avail
 #define	uma_limit _bsd_uma_limit
+#define	uma_prealloc _bsd_uma_prealloc
 #define	uma_print_stats _bsd_uma_print_stats
 #define	uma_print_zone _bsd_uma_print_zone
 #define	uma_reclaim _bsd_uma_reclaim
@@ -5490,6 +5973,9 @@
 #define	uma_zone_set_zinit _bsd_uma_zone_set_zinit
 #define	uma_zsecond_create _bsd_uma_zsecond_create
 #define	uma_zwait _bsd_uma_zwait
+#define	unmapped_base _bsd_unmapped_base
+#define	unmapped_buf _bsd_unmapped_buf
+#define	unmapped_buf_allowed _bsd_unmapped_buf_allowed
 #define	unp_copy_peercred _bsd_unp_copy_peercred
 #define	untimeout _bsd_untimeout
 #define	usb_alloc_device _bsd_usb_alloc_device
@@ -5772,8 +6258,98 @@
 #define	uuid_ether_add _bsd_uuid_ether_add
 #define	uuid_ether_del _bsd_uuid_ether_del
 #define	uuidcmp _bsd_uuidcmp
+#define	v_addpollinfo _bsd_v_addpollinfo
+#define	v_inval_buf_range _bsd_v_inval_buf_range
+#define	va_null _bsd_va_null
+#define	vaccess _bsd_vaccess
+#define	vattr_null _bsd_vattr_null
+#define	vcount _bsd_vcount
+#define	verbose_sysinit _bsd_verbose_sysinit
 #define	vesagtf_mode _bsd_vesagtf_mode
 #define	vesagtf_mode_params _bsd_vesagtf_mode_params
+#define	vflush _bsd_vflush
+#define	vfs_allocate_syncvnode _bsd_vfs_allocate_syncvnode
+#define	vfs_bio_awrite _bsd_vfs_bio_awrite
+#define	vfs_bio_brelse _bsd_vfs_bio_brelse
+#define	vfs_bio_bzero_buf _bsd_vfs_bio_bzero_buf
+#define	vfs_bio_clrbuf _bsd_vfs_bio_clrbuf
+#define	vfs_bio_getpages _bsd_vfs_bio_getpages
+#define	vfs_bio_set_flags _bsd_vfs_bio_set_flags
+#define	vfs_bio_set_valid _bsd_vfs_bio_set_valid
+#define	vfs_buildopts _bsd_vfs_buildopts
+#define	vfs_busy _bsd_vfs_busy
+#define	vfs_busy_pages _bsd_vfs_busy_pages
+#define	vfs_busyfs _bsd_vfs_busyfs
+#define	vfs_byname _bsd_vfs_byname
+#define	vfs_byname_kld _bsd_vfs_byname_kld
+#define	vfs_cache_lookup _bsd_vfs_cache_lookup
+#define	vfs_copyopt _bsd_vfs_copyopt
+#define	vfs_deallocate_syncvnode _bsd_vfs_deallocate_syncvnode
+#define	vfs_deleteopt _bsd_vfs_deleteopt
+#define	vfs_donmount _bsd_vfs_donmount
+#define	vfs_drain_busy_pages _bsd_vfs_drain_busy_pages
+#define	vfs_event_signal _bsd_vfs_event_signal
+#define	vfs_export _bsd_vfs_export
+#define	vfs_filteropt _bsd_vfs_filteropt
+#define	vfs_flagopt _bsd_vfs_flagopt
+#define	vfs_freeopts _bsd_vfs_freeopts
+#define	vfs_getnewfsid _bsd_vfs_getnewfsid
+#define	vfs_getopt _bsd_vfs_getopt
+#define	vfs_getopt_pos _bsd_vfs_getopt_pos
+#define	vfs_getopt_size _bsd_vfs_getopt_size
+#define	vfs_getopts _bsd_vfs_getopts
+#define	vfs_getvfs _bsd_vfs_getvfs
+#define	vfs_hash_changesize _bsd_vfs_hash_changesize
+#define	vfs_hash_get _bsd_vfs_hash_get
+#define	vfs_hash_index _bsd_vfs_hash_index
+#define	vfs_hash_insert _bsd_vfs_hash_insert
+#define	vfs_hash_ref _bsd_vfs_hash_ref
+#define	vfs_hash_rehash _bsd_vfs_hash_rehash
+#define	vfs_hash_remove _bsd_vfs_hash_remove
+#define	vfs_kqfilter _bsd_vfs_kqfilter
+#define	vfs_mark_atime _bsd_vfs_mark_atime
+#define	vfs_modevent _bsd_vfs_modevent
+#define	vfs_mount_alloc _bsd_vfs_mount_alloc
+#define	vfs_mount_destroy _bsd_vfs_mount_destroy
+#define	vfs_mount_error _bsd_vfs_mount_error
+#define	vfs_mountedfrom _bsd_vfs_mountedfrom
+#define	vfs_msync _bsd_vfs_msync
+#define	vfs_notify_upper _bsd_vfs_notify_upper
+#define	vfs_oexport_conv _bsd_vfs_oexport_conv
+#define	vfs_opterror _bsd_vfs_opterror
+#define	vfs_read_dirent _bsd_vfs_read_dirent
+#define	vfs_ref _bsd_vfs_ref
+#define	vfs_rel _bsd_vfs_rel
+#define	vfs_scanopt _bsd_vfs_scanopt
+#define	vfs_setopt _bsd_vfs_setopt
+#define	vfs_setopt_part _bsd_vfs_setopt_part
+#define	vfs_setopts _bsd_vfs_setopts
+#define	vfs_setpublicfs _bsd_vfs_setpublicfs
+#define	vfs_stdcheckexp _bsd_vfs_stdcheckexp
+#define	vfs_stdextattrctl _bsd_vfs_stdextattrctl
+#define	vfs_stdfhtovp _bsd_vfs_stdfhtovp
+#define	vfs_stdinit _bsd_vfs_stdinit
+#define	vfs_stdnosync _bsd_vfs_stdnosync
+#define	vfs_stdquotactl _bsd_vfs_stdquotactl
+#define	vfs_stdroot _bsd_vfs_stdroot
+#define	vfs_stdstatfs _bsd_vfs_stdstatfs
+#define	vfs_stdsync _bsd_vfs_stdsync
+#define	vfs_stdsysctl _bsd_vfs_stdsysctl
+#define	vfs_stduninit _bsd_vfs_stduninit
+#define	vfs_stdvget _bsd_vfs_stdvget
+#define	vfs_suser _bsd_vfs_suser
+#define	vfs_timestamp _bsd_vfs_timestamp
+#define	vfs_unbusy _bsd_vfs_unbusy
+#define	vfs_unbusy_pages _bsd_vfs_unbusy_pages
+#define	vfs_unixify_accmode _bsd_vfs_unixify_accmode
+#define	vfs_unmountall _bsd_vfs_unmountall
+#define	vfs_write_resume _bsd_vfs_write_resume
+#define	vfs_write_suspend _bsd_vfs_write_suspend
+#define	vfs_write_suspend_umnt _bsd_vfs_write_suspend_umnt
+#define	vfsconf _bsd_vfsconf
+#define	vfsconf_sx _bsd_vfsconf_sx
+#define	vget _bsd_vget
+#define	vgone _bsd_vgone
 #define	vht80_chan_ranges _bsd_vht80_chan_ranges
 #define	vid_allocate _bsd_vid_allocate
 #define	vid_configure _bsd_vid_configure
@@ -5787,6 +6363,8 @@
 #define	videomode_count _bsd_videomode_count
 #define	videomode_list _bsd_videomode_list
 #define	vidsw _bsd_vidsw
+#define	vinactive _bsd_vinactive
+#define	vinvalbuf _bsd_vinvalbuf
 #define	vlan_cookie_p _bsd_vlan_cookie_p
 #define	vlan_devat_p _bsd_vlan_devat_p
 #define	vlan_input_p _bsd_vlan_input_p
@@ -5798,11 +6376,125 @@
 #define	vlan_trunk_cap_p _bsd_vlan_trunk_cap_p
 #define	vlan_trunkdev_p _bsd_vlan_trunkdev_p
 #define	vlog _bsd_vlog
+#define	vm_cnt _bsd_vm_cnt
+#define	vm_pager_bufferinit _bsd_vm_pager_bufferinit
+#define	vmapbuf _bsd_vmapbuf
+#define	vmem_alloc _bsd_vmem_alloc
+#define	vmem_free _bsd_vmem_free
+#define	vmiodirenable _bsd_vmiodirenable
+#define	vn_bmap_seekhole _bsd_vn_bmap_seekhole
+#define	vn_chmod _bsd_vn_chmod
+#define	vn_chown _bsd_vn_chown
+#define	vn_close _bsd_vn_close
+#define	vn_commname _bsd_vn_commname
+#define	vn_dir_check_exec _bsd_vn_dir_check_exec
+#define	vn_dir_dd_ino _bsd_vn_dir_dd_ino
+#define	vn_extattr_get _bsd_vn_extattr_get
+#define	vn_extattr_rm _bsd_vn_extattr_rm
+#define	vn_extattr_set _bsd_vn_extattr_set
+#define	vn_fill_kinfo _bsd_vn_fill_kinfo
+#define	vn_fill_kinfo_vnode _bsd_vn_fill_kinfo_vnode
+#define	vn_finished_secondary_write _bsd_vn_finished_secondary_write
+#define	vn_finished_write _bsd_vn_finished_write
+#define	vn_fsid _bsd_vn_fsid
+#define	vn_fsync_buf _bsd_vn_fsync_buf
+#define	vn_fullpath _bsd_vn_fullpath
+#define	vn_fullpath_global _bsd_vn_fullpath_global
+#define	vn_io_fault_pgmove _bsd_vn_io_fault_pgmove
+#define	vn_io_fault_uiomove _bsd_vn_io_fault_uiomove
+#define	vn_isdisk _bsd_vn_isdisk
+#define	vn_open _bsd_vn_open
+#define	vn_open_cred _bsd_vn_open_cred
+#define	vn_open_vnode _bsd_vn_open_vnode
+#define	vn_pages_remove _bsd_vn_pages_remove
+#define	vn_path_to_global_path _bsd_vn_path_to_global_path
+#define	vn_pollrecord _bsd_vn_pollrecord
+#define	vn_printf _bsd_vn_printf
+#define	vn_rdwr _bsd_vn_rdwr
+#define	vn_rdwr_inchunks _bsd_vn_rdwr_inchunks
+#define	vn_rlimit_fsize _bsd_vn_rlimit_fsize
+#define	vn_seek _bsd_vn_seek
+#define	vn_start_secondary_write _bsd_vn_start_secondary_write
+#define	vn_start_write _bsd_vn_start_write
+#define	vn_stat _bsd_vn_stat
+#define	vn_utimes_perm _bsd_vn_utimes_perm
+#define	vn_vget_ino _bsd_vn_vget_ino
+#define	vn_vget_ino_gen _bsd_vn_vget_ino_gen
+#define	vn_vptocnp _bsd_vn_vptocnp
+#define	vn_writechk _bsd_vn_writechk
 #define	vnet_if_clone_init _bsd_vnet_if_clone_init
+#define	vnlru_free _bsd_vnlru_free
+#define	vnops _bsd_vnops
+#define	vntype_to_kinfo _bsd_vntype_to_kinfo
+#define	vop_close_post _bsd_vop_close_post
+#define	vop_create_post _bsd_vop_create_post
+#define	vop_deleteextattr_post _bsd_vop_deleteextattr_post
+#define	vop_ebadf _bsd_vop_ebadf
+#define	vop_einval _bsd_vop_einval
+#define	vop_enoent _bsd_vop_enoent
+#define	vop_enotty _bsd_vop_enotty
+#define	vop_eopnotsupp _bsd_vop_eopnotsupp
+#define	vop_link_post _bsd_vop_link_post
+#define	vop_mkdir_post _bsd_vop_mkdir_post
+#define	vop_mknod_post _bsd_vop_mknod_post
+#define	vop_nopoll _bsd_vop_nopoll
+#define	vop_null _bsd_vop_null
+#define	vop_open_post _bsd_vop_open_post
+#define	vop_panic _bsd_vop_panic
+#define	vop_read_post _bsd_vop_read_post
+#define	vop_readdir_post _bsd_vop_readdir_post
+#define	vop_reclaim_post _bsd_vop_reclaim_post
+#define	vop_remove_post _bsd_vop_remove_post
+#define	vop_rename_fail _bsd_vop_rename_fail
+#define	vop_rename_post _bsd_vop_rename_post
+#define	vop_rename_pre _bsd_vop_rename_pre
+#define	vop_rmdir_post _bsd_vop_rmdir_post
+#define	vop_setattr_post _bsd_vop_setattr_post
+#define	vop_setextattr_post _bsd_vop_setextattr_post
+#define	vop_stdaccess _bsd_vop_stdaccess
+#define	vop_stdaccessx _bsd_vop_stdaccessx
+#define	vop_stdadvise _bsd_vop_stdadvise
+#define	vop_stdadvlock _bsd_vop_stdadvlock
+#define	vop_stdadvlockasync _bsd_vop_stdadvlockasync
+#define	vop_stdadvlockpurge _bsd_vop_stdadvlockpurge
+#define	vop_stdallocate _bsd_vop_stdallocate
+#define	vop_stdbmap _bsd_vop_stdbmap
+#define	vop_stdfdatasync_buf _bsd_vop_stdfdatasync_buf
+#define	vop_stdfsync _bsd_vop_stdfsync
+#define	vop_stdgetpages _bsd_vop_stdgetpages
+#define	vop_stdgetwritemount _bsd_vop_stdgetwritemount
+#define	vop_stdislocked _bsd_vop_stdislocked
+#define	vop_stdkqfilter _bsd_vop_stdkqfilter
+#define	vop_stdlock _bsd_vop_stdlock
+#define	vop_stdpathconf _bsd_vop_stdpathconf
+#define	vop_stdpoll _bsd_vop_stdpoll
+#define	vop_stdputpages _bsd_vop_stdputpages
+#define	vop_stdset_text _bsd_vop_stdset_text
+#define	vop_stdunlock _bsd_vop_stdunlock
+#define	vop_stdunp_bind _bsd_vop_stdunp_bind
+#define	vop_stdunp_connect _bsd_vop_stdunp_connect
+#define	vop_stdunp_detach _bsd_vop_stdunp_detach
+#define	vop_stdvptocnp _bsd_vop_stdvptocnp
+#define	vop_stdvptofh _bsd_vop_stdvptofh
+#define	vop_symlink_post _bsd_vop_symlink_post
 #define	vprintf _bsd_vprintf
+#define	vput _bsd_vput
+#define	vrecycle _bsd_vrecycle
+#define	vrecyclel _bsd_vrecyclel
+#define	vref _bsd_vref
+#define	vrefact _bsd_vrefact
+#define	vrefcnt _bsd_vrefcnt
+#define	vrefl _bsd_vrefl
+#define	vrele _bsd_vrele
 #define	vsnprintf _bsd_vsnprintf
 #define	vsnrprintf _bsd_vsnrprintf
 #define	vsprintf _bsd_vsprintf
+#define	vtprintf _bsd_vtprintf
+#define	vtruncbuf _bsd_vtruncbuf
+#define	vttoif_tab _bsd_vttoif_tab
+#define	vunmapbuf _bsd_vunmapbuf
+#define	vunref _bsd_vunref
+#define	waitrunningbufspace _bsd_waitrunningbufspace
 #define	wakeup _bsd_wakeup
 #define	wakeup_any _bsd_wakeup_any
 #define	wakeup_one _bsd_wakeup_one
diff --git a/rtemsbsd/include/machine/rtems-bsd-kernel-space.h b/rtemsbsd/include/machine/rtems-bsd-kernel-space.h
index 09bcecf1..37bd701d 100644
--- a/rtemsbsd/include/machine/rtems-bsd-kernel-space.h
+++ b/rtemsbsd/include/machine/rtems-bsd-kernel-space.h
@@ -3,10 +3,12 @@
  *
  * @ingroup rtems_bsd_machine
  *
- * @brief TODO.
+ * @brief RTEMS FreeBSD Kernel related machine settings and defines
  */
 
 /*
+ * Copyright (c) 2020-2021 Chris Johns <chrisj@rtems.org>.  All rights reserved.
+ *
  * Copyright (c) 2009-2013 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
@@ -40,23 +42,82 @@
 #ifndef _RTEMS_BSD_MACHINE_RTEMS_BSD_KERNEL_SPACE_H_
 #define _RTEMS_BSD_MACHINE_RTEMS_BSD_KERNEL_SPACE_H_
 
-/* FIXME: Update Newlib */
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+/*
+ * FreeBSD warning control
+ */
+#pragma GCC diagnostic ignored "-Wunused-function"
+#pragma GCC diagnostic ignored "-Wunused-value"
+#pragma GCC diagnostic ignored "-Wunused-variable"
+#pragma GCC diagnostic ignored "-Wunused-const-variable"
+#pragma GCC diagnostic ignored "-Waddress-of-packed-member"
+#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
+
+/* FIXME: start: Update Newlib */
 #define MSIZE 256
 
-/* FIXME: Update Newlib */
 #define	__GLOBL1(sym)	__asm__(".globl " #sym)
 #define	__GLOBL(sym)	__GLOBL1(sym)
 
 #define O_CLOEXEC 0
-#define IO_NDELAY O_NONBLOCK
+
+/* FIXME: end: Update Newlib */
+
+#define FSEARCH O_SEARCH
+#define O_FSYNC FSYNC
+
+#define FMASK (FREAD|FWRITE|FAPPEND|FASYNC|FNONBLOCK|O_DIRECT)
+#define FCNTLFLAGS (FAPPEND|FASYNC|FNONBLOCK|O_DIRECT)
+#define FHASLOCK 0
+
+#define PIPE_NODIRECT
+
+#define SEEK_DATA               3       /* set file offset to next data past offset */
+#define SEEK_HOLE               4       /* set file offset to next hole past offset */
+#define L_SET                   SEEK_SET
+#define L_INCR                  SEEK_CUR
+#define L_XTND                  SEEK_END
+#define O_FSYNC                 FSYNC
+#define O_SHLOCK                FSHLOCK
+#define O_EXLOCK                FEXLOCK
+#define POSIX_FADV_NORMAL       0       /* no special treatment */
+#define POSIX_FADV_RANDOM       1       /* expect random page references */
+#define POSIX_FADV_SEQUENTIAL   2       /* expect sequential page references */
+#define POSIX_FADV_WILLNEED     3       /* will need these pages */
+#define POSIX_FADV_DONTNEED     4       /* dont need these pages */
+#define POSIX_FADV_NOREUSE      5       /* access data only once */
+
+/* Used in NFS common code */
+#define __LINUX_ERRNO_EXTENSIONS__ 1
 
 #define __FreeBSD__ 1
 
 /* General define to activate BSD kernel parts */
 #define _KERNEL 1
 
+/*
+ * Various developer tracing options. See waf --help and --freebsd-options.
+ */
+#ifndef RTEMS_BSD_DESCRIP_TRACE
+  #define RTEMS_BSD_DESCRIP_TRACE (0)
+#endif
+#ifndef RTEMS_BSD_SYSCALL_TRACE
+  #define RTEMS_BSD_SYSCALL_TRACE (0)
+#endif
+#ifndef RTEMS_BSD_VFS_TRACE
+  #define RTEMS_BSD_VFS_TRACE (0)
+#endif
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
 #include <machine/rtems-bsd-version.h>
 #include <machine/rtems-bsd-kernel-namespace.h>
+#include <sys/types.h>
 
 #ifdef __cplusplus
 extern "C" {
@@ -74,6 +135,8 @@ void rtems_bsd_assert_func(const char *file, int line, const char *func, const c
 
 /* General definitions */
 
+#define MACHINE "rtems"
+
 #define MACHINE_ARCH "rtems"
 
 #define M_RTEMS_HEAP 0
@@ -95,9 +158,92 @@ void rtems_bsd_assert_func(const char *file, int line, const char *func, const c
 #define	EJUSTRETURN	(-2)		/* don't modify regs, just return */
 #define	ENOIOCTL	(-3)		/* ioctl not handled by this layer */
 #define	EDIRIOCTL	(-4)		/* do direct ioctl in GEOM */
+#define ERELOOKUP       (-5)            /* retry the directory lookup */
+
+/* error codes used in the NFS code */
+#define EBADRPC         72
+#define EPROGMISMATCH   75
+#define EAUTH           80
+#define ENOTCAPABLE     93
 
 #define	EDOOFUS __ELASTERROR
 
+typedef unsigned char   u_char;
+typedef unsigned short  u_short;
+typedef unsigned int    u_int;
+typedef unsigned long   u_long;
+typedef unsigned short  ushort;         /* Sys V compatibility */
+typedef unsigned int    uint;           /* Sys V compatibility */
+
+typedef __UINT64_TYPE__ uoff_t;
+
+#define __LLONG_MAX __LONG_LONG_MAX__
+#define __OFF_MAX   __LLONG_MAX
+#define OFF_MAX     __OFF_MAX
+
+#define F_WAIT          0x010           /* Wait until lock is granted */
+#define F_FLOCK         0x020           /* Use flock(2) semantics for lock */
+#define F_POSIX         0x040           /* Use POSIX semantics for lock */
+#define F_REMOTE        0x080           /* Lock owner is remote NFS client */
+#define F_NOINTR        0x100           /* Ignore signals when waiting */
+
+#define _PC_ACL_EXTENDED        59
+#define _PC_ACL_PATH_MAX        60
+#define _PC_CAP_PRESENT         61
+#define _PC_INF_PRESENT         62
+#define _PC_MAC_PRESENT         63
+#define _PC_ACL_NFS4            64
+
+#define FFLAGS(oflags)  ((oflags) + 1)
+#define OFLAGS(fflags)  ((fflags) - 1)
+
+#define buffer_arena NULL
+extern struct vmem *rtems_bsd_transient_arena;
+#define transient_arena rtems_bsd_transient_arena
+
+struct uma_zone;
+extern struct uma_zone* ncl_pbuf_zone;
+struct uma_zone* pbuf_zsecond_create(char *name, int max);
+
+/*
+ * Device dev_t handling
+ */
+int rtems_bsd__major(dev_t _d);
+int rtems_bsd__minor(dev_t _d);
+dev_t rtems_bsd__makedev(int _M, int _m);
+#define major(d)        rtems_bsd__major(d)
+#define minor(d)        rtems_bsd__minor(d)
+#define makedev(M, m)   rtems_bsd__makedev((M), (m))
+
+/*
+ * VM, avoid bringing the headers across
+ */
+#define VM_OBJECT_WLOCK(object)
+#define VM_OBJECT_WUNLOCK(object)
+
+/*
+ * From freebsd-oirg/sys/sys/dirent.h
+ */
+#define _GENERIC_DIRLEN(namlen)                                 \
+        ((__offsetof(struct dirent, d_name) + (namlen) + 1 + 7) & ~7)
+#define _GENERIC_DIRSIZ(dp)     _GENERIC_DIRLEN((dp)->d_namlen)
+
+/*
+ * From signalvar.h
+ */
+#define SIGISMEMBER(set, signo) (0)
+
+/*
+ * Special knote status bit to indicate the kn_fp is an iop.
+ */
+#define KN_FP_IS_IOP       0x10000000
+
+/*
+ * Ensure that padding bytes are zeroed and that the name is NUL-terminated.
+ */
+struct dirent;
+void dirent_terminate(struct dirent *dp);
+
 #ifdef __cplusplus
 }
 #endif /* __cplusplus */
